// -*- C++ -*-

/* 
 * GChemPaint
 * text.h 
 *
 * Copyright (C) 2002-2003
 *
 * Developed by Jean Bréfort <jean.brefort@ac-dijon.fr>
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

#ifndef GCHEMPAINT_TEXT_H
#define GCHEMPAINT_TEXT_H

#include <chemistry/object.h>
#include <libxml/tree.h>
#include <gtk/gtk.h>

using namespace gcu;

class gcpText: public Object
{
public:
	gcpText();
	gcpText(double x, double y);
	virtual ~gcpText();
	
	void GetCoords(double *x, double *y);
	void SetCoords(double x, double y);
	const GtkTextBuffer* GetTextBuffer() {return m_buf;}
	virtual xmlNodePtr Save(xmlDocPtr xml);
	virtual bool SaveNode(xmlDocPtr xml, xmlNodePtr node, GtkTextIter *iter, GtkTextIter *end, GSList*& TagList, GSList*& OtherTagList);
	virtual bool Load(xmlNodePtr);
	bool LoadNode(xmlNodePtr, GtkTextIter* CurIter);
	bool LoadTaggedNode(xmlNodePtr, GtkTextIter* CurIter, const char* TagName);
	virtual void Add(GtkWidget* w);
	virtual void Move(double x, double y, double z = 0);
	virtual void Update(GtkWidget* w);
	virtual void SetSelected(GtkWidget* w, int state);
	bool OnChanged(GtkTextBuffer *textbuffer);
	bool OnMarkSet(GtkTextBuffer *textbuffer, GtkTextIter *iter, GtkTextMark *mark);
	bool OnInsertText(GtkTextBuffer *textbuffer, GtkTextIter *iter, gchar* newtext, gint length);
	bool OnEndUserAction(GtkTextBuffer *textbuffer);
	void GetSize(double& x, double& y) {x = m_length; y = m_height;}

private:
	double m_x, m_y, m_length, m_height;
	int m_InsertOffset;
	GtkTextBuffer* m_buf;
	bool m_bLoading;
};

#endif	//GCHEMPAINT_TEXT_H
